#ifndef P2_H
#define P2_H

#include <cstdlib>
#include <cstdio>
#include <cmath>

double serial_dot(double *x, double *y, int n);
void Ax(double *v, double *x, int N, double h, double a);
void cg(double *u, int *flag, double *relres, int *iter, double *l_r, 
	double tol, int maxit, double *l_p, double *l_q, int l_n, int l_N, 
	int N, double h, double a);
void poisson(int N, double tol, int maxit, double *maxError, int *iter, 
	     double a);

#endif
